CON
  _clkmode = xtal1 + pll16x     
  _xinfreq = 5_000_000

  ATTEMPTS      = 1
  CR            = 13
  LF            = 10

  BUFFER_LEN    = 256
  MAIN_BUFFER_LEN = $800

VAR

DAT
  header        byte  "HTTP/1.1 200 OK", CR, LF, {
}                     "Content-Type: text/html", CR, LF, CR, LF, {
}                     "Hello World!", CR, LF, $0

  buff            byte  $0[MAIN_BUFFER_LEN]
  
OBJ
  pst             : "Parallax Serial Terminal"
  wiz             : "W5500"

PUB Main | sock, bytesToRead, p

  pst.Start(115_200) 
  pause(500)

  wiz.Start(WIZ#SPI_CS, WIZ#SPI_SCK, WIZ#SPI_MOSI, WIZ#SPI_MISO)

  sock := 0

  wiz.SetMode(0)
  wiz.SetGateway(192,168,1,1)
  wiz.SetMac($00, $08, $DC, $16, $F8, $20)
  wiz.SetIp(192,168,1,130)
  wiz.SetSubnetMask(255,255,255,0)
  
  wiz.SetSocketMode(sock, WIZ#UDP)
  wiz.SetSocketPort(sock, 10000)
  
  wiz.SetRemoteIp(sock, 192,168,1,100) 
  wiz.SetRemotePort(sock, 8000)

  pst.str(string("Starting UDP Service", CR))
  wiz.OpenSocket(sock)
  repeat
    bytesToRead~ 
    
    repeat until bytesToRead := wiz.GetRxBytesToRead(sock)
      pause(50)
      
    pst.str(string("Connection!", CR, CR))
    wiz.Rx(sock, @buff, bytesToRead)
  
    p := wiz.tx(sock, @header, strsize(@header))
    
    

PRI GetVersion | i
  i := 0
  result := 0
  repeat until result > 0
    result := wiz.GetVersion
    if(i++ > ATTEMPTS*5)
      return 0
    pause(250)


PRI PrintIp(label, addr, char) | i
  pst.str(label)
  repeat 25 - strsize(label)
    pst.char(".")
  repeat i from 0 to 3
    pst.dec(byte[addr][i])
    if(i < 3)
      pst.char($2E)

  if(char > 0)
    pst.char(char)

PRI PrintMac(label, addr, char) | i
  pst.str(label)
  repeat 25 - strsize(label)
    pst.char(".")
  repeat i from 0 to 5
    pst.hex(byte[addr][i], 2)
    if(i < 5)
      pst.char("-")

  if(char > 0)
    pst.char(char)
      
PRI ConsoleHex(label, value, digits)
  pst.str(label)
  repeat 25 - strsize(label)
    pst.char(".")

  pst.hex(value, digits)
  pst.char(CR)
  
PRI ConsoleValue(label, value, isNum)
    pst.str(label)
  repeat 25 - strsize(label)
    pst.char(".")
  if(isNum)
    pst.dec(value)
  else
    pst.str(value)
  pst.char(CR)

PUB ConsoleMemory(addr, len, isHex) | j
  pst.str(string(13,"-----------------------------------------------------",13))
  pst.str(string(13, "      "))
  repeat j from 0 to $F
    pst.hex(j, 2)
    pst.char($20)
  pst.str(string(13, "      ")) 
  repeat j from 0 to $F
    pst.str(string("-- "))

  pst.char(13) 
  repeat j from 0 to len
    if(j == 0)
      pst.hex(0, 4)
      pst.char($20)
      pst.char($20)
      
    if(isHex)
      pst.hex(byte[addr + j], 2)
    else
      pst.char($20)
      if(byte[addr+j] == 0)
        pst.char($20)
      pst.char(byte[addr+j])

    pst.char($20) 
    if((j+1) // $10 == 0) 
      pst.char($0D)
      pst.hex(j+1, 4)
      pst.char($20)
      pst.char($20)  
  pst.char(13)
  
  pst.char(13)
  pst.str(string("Start: "))
  pst.dec(addr)
  pst.str(string(" Len: "))
  pst.dec(len)
  pst.str(string(13,"-----------------------------------------------------",13,13))
       
PRI pause(Duration)  
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> 381) + cnt)
  return