'*********************************************************************************************
{
 AUTHOR: Mike Gebhard
 COPYRIGHT: Parallax Inc.
 LAST MODIFIED: 
 VERSION 2.0
 LICENSE: MIT (see end of file)

}
'*********************************************************************************************
CON
  {{ W5200 Common register enumeration }}   
  #0000,  MODE_REG,{
  01-04}  GATEWAY0,      GATEWAY1,      GATEWAY2,      GATEWAY3,{
  05-08}  SUBNET_MASK0,  SUBNET_MASK1,  SUBNET_MASK2,  SUBNET_MASK3,{
  09-0E}  MAC0,          MAC1,          MAC2,          MAC3,          MAC4,          MAC5,{
  0F-12}  SOURCE_IP0,    SOURCE_IP1,    SOURCE_IP2,    SOURCE_IP3,{
  13-14}  NTLEVEL0,      NTLEVEL1,{
  15}     IR,{
  16}     IMR,{
  17}     SIR, {
  18}     SIMR, {
  19-1A}  RTR0,        RTR1,{
  1B}     RETRY_COUNT,{
  1C}     PTIMER,{
  1D}     PMAGIC, {
  1E-23}  PHAR0,  PHAR1, PHAR2, PHAR3, PHAR4, PHAR5,{
  24-25}  PSID0, PSID1,{
  28-2B}  UIPR0, UIPR1, UIPR2, UIPR3,{
  2C-2D}  UPORTR0, UPORTR1, {
  2E}     PHYCFGR,{
  2F-38}  { **** Reserved ********
  --}     VERSIONR = $0039                                                                                  

{{ W5200  Socket Register Base Addresses }}
  #0000,  S_MR,{
 01     } S_CR,{
 02     } S_IR,{
 03     } S_SR,{
 04-05  } S_PORT0,      S_PORT1,{
 06-0B  } S_DEST_MAC0,  S_DEST_MAC1,   S_DEST_MAC2,   S_DEST_MAC3,   S_DEST_MAC4,   S_DEST_MAC5,{
 0C-0F  } S_DEST_IP0,   S_DEST_IP1,    S_DEST_IP2,    S_DEST_IP3,{
 10-11  } S_DEST_PORT0, S_DEST_PORT1,{
 12-13  } S_MAX_SEGM0,  S_MAX_SEGM1,{
 14     } S_RESERVED_14,{
 15     } S_TOS,{
 16     } S_TTL,{
 17-1D  } S_RES17,S_RES18,S_RES19,S_RES1A,S_RES1B,S_RES1C,S_RES1D,{
 1E     } S_RX_MEM_SIZE, {
 1F     } S_TX_MEM_SIZE, {
 20-21  } S_TX_FREE0,   S_TX_FREE1,{
 22-23  } S_TX_R_PTR0,  S_TX_R_PTR1, {
 24-25  } S_TX_W_PTR0,  S_TX_W_PTR1, {
 26-27  } S_RX_RCV_SIZE0,S_RX_RCV_SIZE1,{
 28-29  } S_RX_R_PTR0,  S_RX_R_PTR1, {
 2A-2B  } S_RX_W_PTR0,  S_RX_W_PTR1, {
 2C     } S_INT_MASK, {
 2D-2E  } S_FRAG0, S_FRAG1, {
 2F     } S_KEEP_ALIIVE         {
         Reservered $4n30 to $4nFF}
         
  {{Socket Register Offsets}}
  SOCKET_BASE_ADDRESS = $4000
  SOCKET_REG_SIZE     = $0100

  {{ Socket Buffer Defaults }}
  INTERNAL_RX_BUFFER_ADDRESS    = $C000
  INTERNAL_TX_BUFFER_ADDRESS    = $8000
  DEFAULT_RX_TX_BUFFER          = $800
  DEFAULT_RX_TX_BUFFER_MASK     = DEFAULT_RX_TX_BUFFER - 1

  {{ Socket Command Register }}
  OPEN              = $01
  LISTEN            = $02
  CONNECT           = $04
  DISCONNECT        = $08
  CLOSE             = $10
  SEND              = $20
  SEND_MAC          = $21
  SEND_KEEP         = $22
  RECV              = $40
  'ADSL 
  #$23, PCON, PDISCON, PCR, PCN, PCJ
  
  {{ Status Register States}}
  SOCK_CLOSED       = $00
  SOCK_INIT         = $13
  SOCK_LISTEN       = $14
  SOCK_ESTABLISHED  = $17
  SOCK_CLOSE_WAIT   = $1C
  SOCK_UPD          = $22
  SOCK_IPRAW        = $32
  SOCK_MACRAW       = $42
  SOCK_PPPOE        = $5F
  {{ Status Change States }}
  SOCK_SYSENT       = $15
  SOCK_SYNRECV      = $16
  SOCK_FIN_WAIT     = $18
  SOCK_CLOSING      = $1A
  SOCK_TIME_WAIT    = $1B
  SOCK_LAST_ACK     = $1D
  SOCK_ARP          = $01


  'MACRAW and PPPOE can only be used with socket 0
  #0, CLOSED, TCP, UDP, IPRAW, MACRAW, PPPOE

  'Register types
  #0, COMMON_REGISTER, SOCKET_REGISTER, TX_BUFFER, RX_BUFFER
  
  {{ Buffers }}
  BUFFER_2K         = $800
  BUFFER_WS         = $20

  {{ Number of Sockets }}
  SOCKETS           = 8

  {{ Command Op Codes }}
  #0, READ_OPCODE, WRITE_OPCODE
  #0, R, W 
  #1, BYTE_TYPE, WORD_TYPE, IP_TYPE=4, MAC_TYPE=6

  { W5500 Dev Setup  
  SPI_SCK           = 1 ' SPI clock from master to all slaves
  SPI_MISO          = 2 ' SPI master in serial out from slave
  SPI_MOSI          = 3 ' SPI master out serial in to slave
  SPI_CS            = 0 ' SPI chip select (active low)
  WIZ_POWER_DOWN    = -1 ' Power down (active high)       
  WIZ_INT           = -1 ' Interupt (active low)
  WIZ_RESET         = -1 ' Reset (active low)
   } 
  { Spinneret 2.0    } 
  SPI_SCK           = 27 ' SPI clock from master to all slaves
  SPI_MISO          = 26 ' SPI master in serial out from slave
  SPI_MOSI          = 25 ' SPI master out serial in to slave
  SPI_CS            = 24 ' SPI chip select (active low)
  WIZ_POWER_DOWN    = -1 ' Power down (active high)       
  WIZ_INT           = -1 ' Interupt (active low)
  WIZ_RESET         = -1 ' Reset (active low)

  
DAT
  _mode           byte  %0000_0000                      'enable ping  
  _dns1           byte  $00, $00, $00, $00
  _dns2           byte  $00, $00, $00, $00
  _dns3           byte  $00, $00, $00, $00

  workspace       byte  $0[BUFFER_WS]
  
  sockRxMem       byte  $02[SOCKETS]
  sockTxMem       byte  $02[SOCKETS]
  sockRxBase      word  INTERNAL_RX_BUFFER_ADDRESS[SOCKETS]
  sockRxMask      word  DEFAULT_RX_TX_BUFFER_MASK[SOCKETS]
  sockTxBase      word  INTERNAL_TX_BUFFER_ADDRESS[SOCKETS]
  sockTxMask      word  DEFAULT_RX_TX_BUFFER_MASK[SOCKETS]

  null            long  $00

  _flushB1         long  $00
  _flushB2         long  $00

  _cnt1      long  $00
  _cnt2      long  $00
  

OBJ
  spi           : "SpiCounterPasm.spin"


PUB Start(m_cs, m_clk, m_mosi, m_miso)
{{
DESCRIPTION:
  Initialize default values.  All 8 Rx/Tx bufffers are set to 2k.

PARMS:
  m_cs   - SPI chip select (active low)
  c_clk  - SPI clock from master to all slaves
  m_mosi - SPI master out serial in to slave
  m_miso - SPI master in serial out from slave 

RETURNS:
  Nothing
}}
  'Init the SPI bus
  spi.Init( m_cs, m_clk, m_mosi, m_miso )
  'SoftReset 

  'SetCommonDefaults

  'Set up the interrupt mask register
  'SetIMR2($FF)



'----------------------------------------------------
' Receive data
'----------------------------------------------------  
PUB Rx(sock, buffer, length) | rxPtr

  'Rx memory buffer offset and Physical Rx buffer address
  rxPtr := GetRxReadPointer(sock)

  'Read data
   ReadSocketBuffer(sock, rxPtr, length, RX_BUFFER, buffer)

   'Update   Rx pointer
   rxPtr += length
   rxPtr &= $FFFF
   SetRxReadPointer(sock, rxPtr)

  'Set the command register to receive
  SetSocketCommand(sock, RECV) 

'----------------------------------------------------
' Transmit data
'----------------------------------------------------
PUB Tx(sock, buffer, length) | txPtr

  'Get the Tx start address
  txPtr := GetTxWritePointer(sock)
  
  'write to the tx buffer
  'WriteSocketBuffer(sock, register, len, BuffType, ioBuff)
  WriteSocketBuffer(sock, txPtr, length, TX_BUFFER, buffer)

  ' update the tx pointer
  txPtr += length
  txPtr &= $FFFF
  SetTxWritePointer(sock, txPtr)
  pause(10) 
  'Send
  SetSocketCommand(sock, SEND) 
  return txPtr

  
PUB WriteTx(sock, buffer, length) | txPtr
  'Get the Tx start address
  txPtr := GetTxWritePointer(sock)
  
  'write to the tx buffer
  'WriteSocketBuffer(sock, register, len, BuffType, ioBuff)
  WriteSocketBuffer(sock, txPtr, length, TX_BUFFER, buffer)
  return txPtr
  
PUB ReadTx(sock, buffer, length, ptr) | txPtr
  'Read data
   ReadSocketBuffer(sock, ptr, length, TX_BUFFER, buffer)
  
    
PUB FlushSocket(sock)
  SetSocketCommand(sock, SEND)

  
'----------------------------------------------------
' Socket Commands
'----------------------------------------------------  
PUB OpenSocket(sock)
{{
DESCRIPTION: Open socket(n)

PARMS:
  socket    - Socket ID  
  
RETURNS: Nothing
}}
  SetSocketCommand(sock, OPEN)

PUB StartListener(sock)
{{
DESCRIPTION: Listen on socket(n)

PARMS:
  socket    - Socket ID 
  
RETURNS: Nothing
}}
  SetSocketCommand(sock, LISTEN)



PUB OpenRemoteSocket(sock)
{{
DESCRIPTION: Connect remote socket(n)

PARMS:
  socket    - Socket ID  
  
RETURNS: Nothing
}}
  SetSocketCommand(sock, CONNECT)  

PUB DisconnectSocket(sock)
{{
DESCRIPTION: Disconnect socket(n)

PARMS:
  socket    - Socket ID 
  
RETURNS: Nothing
}}
  SetSocketCommand(sock, DISCONNECT)

PUB CloseSocket(sock)
{{
DESCRIPTION: Close socket(n)

PARMS:
  socket    - Socket ID 
  
RETURNS: Nothing
}}
  SetSocketCommand(sock, CLOSE)

  
'----------------------------------------------------
' Socket Statuses
'----------------------------------------------------
PUB IsInit(sock)
{{
DESCRIPTION: Determine if the socket is initialized

PARMS:
  socket    - Socket ID 
  
RETURNS: True if the socket is initialized; otherwise returns false. 
}}
  return GetSocketStatus(sock) ==  SOCK_INIT

PUB IsEstablished(sock)
{{
DESCRIPTION: Determine if the socket is established

PARMS:
  socket    - Socket ID 
  
RETURNS: True if the socket is established; otherwise returns false. 
}}
  return GetSocketStatus(sock) ==  SOCK_ESTABLISHED

PUB IsCloseWait(sock)
{{
DESCRIPTION: Determine if the socket is close wait

PARMS:
  socket    - Socket ID 
  
RETURNS: True if the socket is close wait; otherwise returns false. 
}}
  return GetSocketStatus(sock) ==  SOCK_CLOSE_WAIT
                           
PUB IsClosed(sock)
{{
DESCRIPTION: Determine if the socket is closed

PARMS:
  socket    - Socket ID 
  
RETURNS: True if the socket is closed; otherwise returns false. 
}}
  return GetSocketStatus(sock) ==  SOCK_CLOSED

PUB SocketStatus(sock)
{{
DESCRIPTION: Read the status of socket(n)

PARMS:
  socket    - Socket ID 
  
RETURNS: Byte: Socket(n) status register
}}
  return GetSocketStatus(sock)  

'----------------------------------------------------
' Common Register Initialize Methods
'----------------------------------------------------

{
PUB SetCommonDefaults
  bytefill(@workspace, 0, BUFFER_WS)
  bytemove(@workspace, @_mode,1)
  Write(MODE_REG, @workspace, 19)
  'SetCommonnMode(0)
  SetDefault2kRxTxBuffers

PUB SetCommonnMode(value)
  workSpace := value & $FF 
  Write(MODE_REG, @workSpace, 1)     
 
PUB RemoteIp(sock, octet3, octet2, octet1, octet0)
  return GetRemoteIp(sock)
 } 

'----------------------------------------------------
' Common Register Properties GET/SET
'----------------------------------------------------
PUB GetVersion
  return ReadCommonRegister(VERSIONR, BYTE_TYPE, @workspace)
  
PUB GetMode
  return ReadCommonRegister(MODE_REG, BYTE_TYPE, @workspace)

PUB SetMode(value)
  WriteCommonRegister(MODE_REG, value, BYTE_TYPE, @workspace)  

PUB GetGatewayIp
  return ReadCommonRegister(GATEWAY0, IP_TYPE, @workspace)

PUB SetGateway(octet3, octet2, octet1, octet0)
  workSpace[0] := octet3 & $FF
  workSpace[1] := octet2 & $FF
  workSpace[2] := octet1 & $FF
  workSpace[3] := octet0 & $FF
  WriteCommonRegister(GATEWAY0, -1, IP_TYPE, @workSpace)

PUB GetMac
  return ReadCommonRegister(MAC0, MAC_TYPE, @workspace)

PUB SetMac(octet5, octet4, octet3, octet2, octet1, octet0)
  workSpace[0] := octet5 & $FF 
  workSpace[1] := octet4 & $FF
  workSpace[2] := octet3 & $FF
  workSpace[3] := octet2 & $FF
  workSpace[4] := octet1 & $FF
  workSpace[5] := octet0 & $FF
  WriteCommonRegister(MAC0, 6, MAC_TYPE, @workspace)
   
PUB GetIp
  return ReadCommonRegister(SOURCE_IP0, IP_TYPE, @workspace)
  
PUB SetIp(octet3, octet2, octet1, octet0)
  workspace[0] := octet3 & $FF 
  workspace[1] := octet2 & $FF
  workspace[2] := octet1 & $FF
  workspace[3] := octet0 & $FF
  WriteCommonRegister(SOURCE_IP0, -1, IP_TYPE, @workSpace)

  
PUB GetSubnetMask
  return ReadCommonRegister(SUBNET_MASK0, IP_TYPE, @workspace)
 
PUB SetSubnetMask(octet3, octet2, octet1, octet0)
  workSpace[0] := octet3 & $FF
  workSpace[1] := octet2 & $FF
  workSpace[2] := octet1 & $FF
  workSpace[3] := octet0 & $FF
  WriteCommonRegister(SUBNET_MASK0, -1, IP_TYPE, @workSpace)    


PUB GetIntLowLevelTimer
  return ReadCommonRegister(NTLEVEL0, WORD_TYPE, @workspace)
   
PUB SetIntLowLevelTimer(value)
  WriteCommonRegister(NTLEVEL0, value, WORD_TYPE, @workspace)

PUB GetInterrupt  
  return ReadCommonRegister(IR, BYTE_TYPE, @workspace)
  
PUB SetInterrupt(value)
  WriteCommonRegister(IR, value, BYTE_TYPE, @workspace) 

PUB GetInterruptMask  
  return ReadCommonRegister(IMR, BYTE_TYPE, @workspace)
  
PUB SetInterruptMask(value)
  WriteCommonRegister(IMR, value, BYTE_TYPE, @workspace)  

PUB GetSocketInterruptId  
  return ReadCommonRegister(SIR, BYTE_TYPE, @workspace)
  
PUB SetSocketInterruptId(value)
  WriteCommonRegister(SIR, value, BYTE_TYPE, @workspace)
  
PUB GetSocketInterruptIdMask  
  return ReadCommonRegister(SIMR, BYTE_TYPE, @workspace)
  
PUB SetSocketInterruptIdMask(value)
  WriteCommonRegister(SIMR, value, BYTE_TYPE, @workspace)
    
PUB GetRetryTime
  return ReadCommonRegister(RTR0, WORD_TYPE, @workspace)  

PUB SetRetryTime(value)
  WriteCommonRegister(RTR0, value, WORD_TYPE, @workspace)   

PUB GetRetryCount  
  return ReadCommonRegister(RETRY_COUNT, BYTE_TYPE, @workspace)
  
PUB SetRetryCount(value)
  WriteCommonRegister(RETRY_COUNT, value, BYTE_TYPE, @workspace)

{
  PPP Common Reister GET/SET not implemented
}

  
'----------------------------------------------------
' Socket Register Properties GET/SET
'----------------------------------------------------

PUB GetSocketMode(sock)
  return ReadSocketRegister(sock, S_MR, BYTE_TYPE, @workspace)  

PUB SetSocketMode(sock, value)
  WriteSocketRegister(sock, S_MR, value, BYTE_TYPE, @workspace)

PUB GetSocketCommand(sock)
  return ReadSocketRegister(sock, S_CR, BYTE_TYPE, @workspace)
  
PUB SetSocketCommand(sock, value)
  WriteSocketRegister(sock, S_CR, value, BYTE_TYPE, @workspace)

PUB GetSocketInterrupt(sock)
  return ReadSocketRegister(sock, S_IR, BYTE_TYPE, @workspace)
  
PUB SetSocketInterrupt(sock, value)
  WriteSocketRegister(sock, S_IR, value, BYTE_TYPE, @workspace)
 
PUB GetSocketStatus(sock)
  return ReadSocketRegister(sock, S_SR, BYTE_TYPE, @workspace)
  
PUB SetSocketStatus(sock, value) 
  WriteSocketRegister(sock, S_SR, value, BYTE_TYPE, @workspace)
  
PUB GetSocketPort(sock)
  return ReadSocketRegister(sock, S_PORT0, WORD_TYPE, @workspace)
  
PUB SetSocketPort(sock, value)
  WriteSocketRegister(sock, S_PORT0, value, WORD_TYPE, @workspace)

'Read only  
PUB GetSocketRemoteMac(sock)
  return ReadSocketRegister(sock, S_DEST_MAC0, MAC_TYPE, @workspace)


PUB GetRemoteIp(sock)
  return ReadSocketRegister(sock, S_DEST_IP0, IP_TYPE, @workspace)

PUB SetRemoteIp(sock, octet3, octet2, octet1, octet0)
  workSpace[0] := octet3 & $FF
  workSpace[1] := octet2 & $FF
  workSpace[2] := octet1 & $FF
  workSpace[3] := octet0 & $FF
  WriteSocketRegister(sock, S_DEST_IP0, -1, IP_TYPE, @workspace)

PUB GetRemotePort(sock)
  return ReadSocketRegister(sock, S_DEST_PORT0, WORD_TYPE, @workspace)
  
PUB SetRemotePort(sock, value)
  WriteSocketRegister(sock, S_DEST_PORT0, value, WORD_TYPE, @workspace)

PUB GetMaximumSegmentSize(sock)
  return ReadSocketRegister(sock, S_MAX_SEGM0, WORD_TYPE, @workspace)
  
PUB SetMaximumSegmentSize(sock, value)
  WriteSocketRegister(sock, S_MAX_SEGM0, value, WORD_TYPE, @workspace)

PUB GetTos(sock)
  return ReadSocketRegister(sock, S_TOS, BYTE_TYPE, @workspace)
  
PUB SetTos(sock, value)
  WriteSocketRegister(sock, S_TOS, value, BYTE_TYPE, @workspace)

PUB GetTimeToLive(sock)
  return ReadSocketRegister(sock, S_TTL, BYTE_TYPE, @workspace)
  
PUB SetTimeToLive(sock, value)
  WriteSocketRegister(sock, S_TTL, value, BYTE_TYPE, @workspace)    


  
'----------------------------------------------------
' Socket Rx/Tx Pointers
'----------------------------------------------------
PUB SocketRxSize(sock)
{{  
DESCRIPTION: Configuration: Rx socket(n) size in bytes 

PARMS:
  socket    - Socket ID 
  
RETURNS: Rx socket(n) size in bytes 
}}
  return ReadSocketRegister(sock, S_RX_MEM_SIZE, WORD_TYPE, @workspace)

PUB SocketTxSize(sock)
{{    
DESCRIPTION: Configuration: Tx socket(n) size in bytes 

PARMS:
  socket    - Socket ID 
  
RETURNS: Tx socket(n) size in bytes
}}
  return ReadSocketRegister(sock, S_TX_MEM_SIZE, WORD_TYPE, @workspace) 


PUB GetFreeTxSize(sock)
{{
DESCRIPTION:
  Read 2 byte socket(n) Tx available size register
  
PARMS:
  socket    - Socket ID
   
RETURNS:
  2 bytes: Socket(n) available Tx size   
}}
  return ReadSocketRegister(sock, S_TX_FREE0, WORD_TYPE, @workspace)


PUB GetTxReadPointer(sock)
{{
DESCRIPTION: Read socket(n) Tx read pointer 

PARMS:
  socket    - Socket ID 
  
RETURNS: 2 bytes: Socket(n) Tx read pointer 
}}
  return ReadSocketRegister(sock, S_TX_R_PTR0, WORD_TYPE, @workspace)


PUB GetTxWritePointer(sock)
{{
DESCRIPTION: Read socket(n) Tx write pointer

PARMS:
  socket    - Socket ID
  
RETURNS: 2 bytes: Socket(n) Tx write pointer   
}}
  return ReadSocketRegister(sock, S_TX_W_PTR0, WORD_TYPE, @workspace)
  
PUB SetTxWritePointer(sock, value)
{{
DESCRIPTION: Write socket(n) Tx write pointer 

PARMS:
  socket    - Socket ID 
  
RETURNS: 2 bytes: Socket(n) Tx write pointer 
}}
  WriteSocketRegister(sock, S_TX_W_PTR0, value, WORD_TYPE, @workspace)
  
PUB GetRxBytesToRead(sock)
{{
DESCRIPTION:
  Read socket(n) receive size register
  
PARMS:
  socket    - Socket ID
    
RETURNS:
  2 bytes: Number of bytes received
}}
  return ReadSocketRegister(sock, S_RX_RCV_SIZE0, WORD_TYPE, @workspace) 

PUB GetRxReadPointer(sock)
{{
DESCRIPTION: Read socket(n) Rx read pointer

PARMS:
  socket    - Socket ID
  
RETURNS: 2 bytes: Socket(n) Rx read pointer   
}}
  return ReadSocketRegister(sock, S_RX_R_PTR0, WORD_TYPE, @workspace)

PUB SetRxReadPointer(sock, value)
{{
DESCRIPTION: Write socket(n) Rx read pointer

PARMS:
  socket    - Socket ID
  
RETURNS: Nothing  
}}
  WriteSocketRegister(sock, S_RX_R_PTR0, value, WORD_TYPE, @workspace) 

PUB GetRxWritePointer(sock)
{{
DESCRIPTION: Read socket(n) Rx read pointer

PARMS:
  socket    - Socket ID
  
RETURNS: 2 bytes: Socket(n) Rx read pointer   
}}
  return ReadSocketRegister(sock, S_RX_W_PTR0, WORD_TYPE, @workspace)

PUB SetRxWritePointer(sock, value)
{{
DESCRIPTION: Write socket(n) Rx read pointer

PARMS:
  socket    - Socket ID
  
RETURNS: Nothing  
}}
  WriteSocketRegister(sock, S_RX_W_PTR0, value, WORD_TYPE, @workspace)
 
PUB GetSocketInterruptMask(sock)
  return ReadSocketRegister(sock, S_INT_MASK, BYTE_TYPE, @workspace) 

PUB SetSocketInterruptMask(sock, value)
  WriteSocketRegister(sock, S_INT_MASK, value, BYTE_TYPE, @workspace)

PUB GetSocketFragment(sock)
  return ReadSocketRegister(sock, S_FRAG0, WORD_TYPE, @workspace)
  
PUB SetSocketFragment(sock, value)
  WriteSocketRegister(sock, S_FRAG0, value, WORD_TYPE, @workspace)

PUB GetSocketKeepAlive(sock)
  return ReadSocketRegister(sock, S_KEEP_ALIIVE, BYTE_TYPE, @workspace)

PUB SetSocketKeepAlive(sock, value)
  WriteSocketRegister(sock, S_KEEP_ALIIVE, value, BYTE_TYPE, @workspace)  

    
''
''*************************************************************************************
''SPI methods
''*************************************************************************************
''
PUB ReadCommonRegister(register, len, ioBuff) | cmd

  cmd :=  ((register & $FF) << 16) + ((R & $01) << 10)
  spi.ReadWrite(cmd, len, ioBuff)
  case len
    BYTE_TYPE: return byte[ioBuff][0]
    WORD_TYPE: return DeserializeWord(ioBuff)
    other: return ioBuff


PUB WriteCommonRegister(register, value, len, ioBuff) | cmd

  cmd :=  ((register & $FF) << 16) + ((W & $01) << 10)
  case len
    BYTE_TYPE: byte[ioBuff][0] := (value & $FF)
    WORD_TYPE: SerializeWord((value & $FFFF), ioBuff)
  spi.ReadWrite(cmd, len, ioBuff)
  

PUB ReadSocketRegister(sock, register, len, ioBuff) | cmd

  cmd :=  ((register & $FF) << 16) + ((sock & $07) << 13) + (SOCKET_REGISTER << 11) + ((R & $01) << 10)
  spi.ReadWrite(cmd, len, ioBuff)
  case len
    BYTE_TYPE: return byte[ioBuff][0]
    WORD_TYPE: return DeserializeWord(ioBuff)
    other: return ioBuff


PUB WriteSocketRegister(sock, register, value, len, ioBuff) | cmd

  cmd :=  ((register & $FF) << 16) + ((sock & $07) << 13) + (SOCKET_REGISTER << 11) + ((W & $01) << 10)
  case len
    BYTE_TYPE: byte[ioBuff][0] := (value & $FF)
    WORD_TYPE: SerializeWord((value & $FFFF), ioBuff)
  spi.ReadWrite(cmd, len, ioBuff)


PUB ReadSocketBuffer(sock, register, len, BuffType, ioBuff) | cmd

  cmd :=  ((register & $FFFF) << 16) + ((sock & $07) << 13) + (BuffType << 11) + ((R & $01) << 10)
  spi.ReadWrite(cmd, len, ioBuff)
  return ioBuff


PUB WriteSocketBuffer(sock, register, len, BuffType, ioBuff) | cmd

  cmd :=  ((register & $FFFF) << 16) + ((sock & $07) << 13) + (BuffType << 11) + ((W & $01) << 10)
  spi.ReadWrite(cmd, len, ioBuff)
  




PRI BufferValueType(value, len, ioBuff)
    case len
      BYTE_TYPE: byte[ioBuff][0] := (value & $FF)
      WORD_TYPE: SerializeWord((value & $FFFF), ioBuff)  
 
 
'----------------------------------------------------
' Helper Methods
'---------------------------------------------------- 
PUB SerializeWord(value, buffer)
  byte[buffer++] := (value & $FF00) >> 8
  byte[buffer] := value & $FF 

PUB DeserializeWord(buffer) | value
  value := byte[buffer++] << 8
  value += byte[buffer]
  return value

PUB IsNullIp(ipaddr)
  return (byte[ipaddr][0] + byte[ipaddr][1] + byte[ipaddr][2] + byte[ipaddr][3]) == 0    


' Deprecated
{
PUB GetSocketRegister(sock, register)
  return sock * SOCKET_REG_SIZE + SOCKET_BASE_ADDRESS + register

   }
  
'----------------------------------------------------
' Deprecated SPI Interface
'----------------------------------------------------
{
PUB Read(register, buffer, length) 
  spi.Read(register, length, buffer)

PUB Write(register, buffer, length) 
  spi.Write(register, length, buffer)

    
PUB ReadByte(register) 
  spi.Read(register, 1, @workSpace)
  return workSpace[0] & $FF

PUB WriteByte(register, value) 
  workSpace[0] := value
  spi.Write(register, 1, @workSpace)

 }



'----------------------------------------------------
' Set defaults
'----------------------------------------------------     
PUB SetDefault2kRxTxBuffers | i
{{
DESCRIPTION:

PARMS:
  
RETURNS:
  
}}
  repeat i from 0 to 7
    sockRxMem[i] := $02
    sockTxMem[i] := $02
    
  repeat i from 0 to 7
    sockRxMask[i] := DEFAULT_RX_TX_BUFFER_MASK
    sockTxMask[i] := DEFAULT_RX_TX_BUFFER_MASK

  repeat i from 1 to 7
    sockRxBase[i] := sockRxBase[i-1] + DEFAULT_RX_TX_BUFFER
    sockTxBase[i] := sockTxBase[i-1] + DEFAULT_RX_TX_BUFFER

  'repeat i from 0 to 7
    'WriteByte(GetSocketRegister(i, S_RX_MEM_SIZE) , sockRxMem[i])
    'WriteByte(GetSocketRegister(i, S_TX_MEM_SIZE) , sockTxMem[i])  


'----------------------------------------------------
' Wrapped Socket Register Methods
'----------------------------------------------------
{
PUB SetSocketMode(socket, value)
  SocketWriteByte(socket, S_MR, value)
          }
          {     
PUB SetSocketPort(socket, port)
  SocketWriteWord(socket, S_PORT0, port)
           }
{
PUB GetSocketPort(socket)
  return ReadSocketWord(socket, S_PORT0)
  
PUB SetSocketCommandRegister(socket, value)
  SocketWriteByte(socket, S_CR, value)

PUB GetSocketCommandRegister(socket)
  return SocketReadByte(socket, S_CR)      }
{
PUB GetSocketStatus(socket)
  return SocketReadByte(socket, S_SR)

 
PUB GetSocketIR(socket)
  return SocketReadByte(socket, S_IR)

PUB SetSocketIR(socket, value)
  SocketWriteByte(socket, S_IR, value)
 }        
'----------------------------------------------------
' Socket Helper Methods
'----------------------------------------------------
{
PUB ReadSocketWord(socket, register)
  Read(GetSocketRegister(socket, register), @workSpace, 2)
  return DeserializeWord(@workSpace)

PUB ReadSocketByte(socket, register)
  return ReadByte(GetSocketRegister(socket, register)) 
  
PUB SocketWriteWord(socket, register, value)
  SerializeWord(value, @workSpace)
  Write(GetSocketRegister(socket, register), @workSpace, 2)

PUB SocketReadByte(socket, register)
  return ReadByte(GetSocketRegister(socket, register))
  
PUB SocketWriteByte(socket, register, value)
  WriteByte(GetSocketRegister(socket, register), value)
 }
PUB QS_Init
{{
DESCRIPTION:
  Initialize default values for the WizNet 5200 for QuickStart board.
  
  All 8 Rx/Tx bufffers are set to 2k.

PARMS:
  None

RETURNS:
  Nothing
}}
  HardReset(WIZ_RESET)
  waitcnt(((clkfreq / 1_000 * 1500) #> 381) + cnt )
  Start(SPI_CS, SPI_SCK, SPI_MOSI, SPI_MISO)

PUB ReStart
  spi.ReStart

PUB Stop
  spi.Stop

PUB GetCogId
  return spi.GetCogId
  
PUB HardReset(pin) | uSec, mSec
{{
DESCRIPTION:
  Reset the W5200.  This action will clear all W5200 register values  

PARMS:
  Pin     - W5200 reset pin 

RETURNS:
  Nothing
}}
                                                         
  uSec := ((clkfreq / 1_000_000) * 5) #> 381
  mSec := ((clkfreq / 1_000) * 200) #> 381 
  
  dira[pin]~~
  outa[pin]~
  waitcnt(uSec + cnt)
  outa[pin]~~
  waitcnt(mSec + cnt)
  dira[pin]~
  'waitcnt(mSec*5 + cnt) 
  

  
'PUB SoftReset
{{
DESCRIPTION:
  Software reset will clear all W5200 register values  

PARMS:
  None

RETURNS:
  Nothing
}}
{
  bytemove(@workspace, %1000_0000, 1)
  Write(MODE_REG, @workspace, 1)
  }


PUB PowerDown(pin)
{{
DESCRIPTION:
   

PARMS:
  None

RETURNS:
  Nothing
}}
  dira[pin]~~
  outa[pin]~~

PUB PowerUp(pin)
{{
DESCRIPTION:
   

PARMS:
  None

RETURNS:
  Nothing
}}
  dira[pin]~~
  outa[pin]~
  
PUB IsInt(pin)
{{
DESCRIPTION:
  Read the W5200 Interupt pin. A high on the nInt pin means an
  interupt has occured. Use GetSocketIR(sock) to read a socket interupt
  status byte.  wiz.SetSocketIR(sock, $FF) will reset the socket interupt.  

PARMS:
  Pin     - W5200 pin to read.  

RETURNS:
  Nothing
}}
  dira[pin]~
  return ina[pin] 

  
PUB InitSocket(socket, protocol, port)
{{
DESCRIPTION:
  Initialize a socket.
  W5100 has 4 sockets
  W5200 has 8 sockets

PARMS:
  socket    - Socket ID to initialize (0-n)
  protocol  - TCP/UPD
  port      - Listener port (0-65535)  

RETURNS:
  Nothing
}}
  SetSocketMode(socket, protocol)
  SetSocketPort(socket, port)




'----------------------------------------------------
' Debug stuff
'---------------------------------------------------- 
PUB Cnt1
  return spi.Cnt1

PUB Cnt2
  return spi.Cnt2

PUB GetWorkspace
  return @workspace


  

 {{ 
'----------------------------------------------------
' DHCP and DNS
' These methods are accessed by DHCP and DNS
' objects
'----------------------------------------------------
PUB CopyDns(source, len)
  bytemove(@_dns1, source, len)

PUB CopyGateway(source, len)
  bytemove(@workspace, source, len)
  Write(GATEWAY0, @workspace, 4)

PUB CopySubnet(source, len)
  bytemove(@workspace, source, len)
  Write(SUBNET_MASK0, @workspace, 4)

PUB GetDns
  return GetDnsByIndex(0)

PUB GetDnsByIndex(idx)
  if(IsNullIp( @_dns1 + idx*4 ) )
    return NULL
  return @_dns1 + idx*4
 
}}

PRI pause(Duration)  
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> 381) + cnt)
  return

CON
{{
 ______________________________________________________________________________________________________________________________
|                                                   TERMS OF USE: MIT License                                                  |                                                            
|______________________________________________________________________________________________________________________________|
|Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    |     
|files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    |
|modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software|
|is furnished to do so, subject to the following conditions:                                                                   |
|                                                                                                                              |
|The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.|
|                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          |
|WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         |
|COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   |
|ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         |
 ------------------------------------------------------------------------------------------------------------------------------ 
}}